VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormModelRescaler 
   Caption         =   "Model Rescaler"
   ClientHeight    =   2835
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3120
   OleObjectBlob   =   "FormModelRescaler.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FormModelRescaler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'--------------------------------------------------------------------05/12/2004
' ModelRescaler.swp - Copyright 2003 Leonard Kikstra
'------------------------------------------------------------------------------
' This macro will dimensionally rescale a SolidWorks part model by traversing
' all features and dimensions in the part model and multiplying/dividing a user
' defined value to each dimensions.  This macro checks for linked dimensions to
' avoid changing them multiple times.  Changes are made according to the data
' in the form.  To undo changes, rescale by same value in opposite direction.
'------------------------------------------------------------------------------
Dim FileType As Integer         ' Active document type
Dim DisplayDim As Object        ' Dimension object
Dim Feature As Object           ' Current model feature
Dim Title As String
Const swDimensionParamTypeUnknown = -1
Const swDimensionParamTypeDoubleLinear = 0
Const swDimensionParamTypeDoubleAngular = 1
Const swDimensionParamTypeInteger = 2
Const Version = "1.00"

Private Sub FixFeature(ThisFeature)
' If ThisFeature.GetTypeName <> "ProfileFeature" Then
    Set swDispDim = ThisFeature.GetFirstDisplayDimension
    Do While Not swDispDim Is Nothing
      Set swDim = swDispDim.GetDimension
      If swDim.GetType <> swDimensionParamTypeDoubleAngular Then
        Search = False
        Name1 = swDim.FullName
        position = 0
        For x = 1 To Len(Name1)
          If (Mid(Name1, x, 1) = "@") And (position < 5) Then position = x
        Next x
        Name2 = Left$(Name1, position - 1)
        For x = 0 To ListBoxCompleted.ListCount - 1   ' Did we changed dim yet?
          If swDim.FullName = ListBoxCompleted.List(x, 0) _
                                Then Search = True
          If Name2 = Left$(ListBoxCompleted.List(x, 0), Len(Name2)) _
                                Then Search = True
        Next
        If Search = False Then                        ' Did not change dim yet!
          DimValue = swDim.GetSystemValue2("")        ' Change dimension
          If OptionButtonIncrement.Value = True Then
            DimValue = DimValue * TextBoxFactor.Value ' Increase dim value
          Else
            DimValue = DimValue / TextBoxFactor.Value ' Decrease dim value
          End If
          swDim.SetSystemValue2 DimValue, swSetValue_UseCurrentSetting
          ListBoxCompleted.AddItem swDim.FullName     ' Add to list of changed
        End If
      End If
      Set swDispDim = ThisFeature.GetNextDisplayDimension(swDispDim)
    Loop
' End If
End Sub

Private Sub CommandButtonZoomAll_Click()
  Document.ViewZoomtofit
End Sub

'------------------------------------------------------------------------------
' Traverse each model feature and update all dimensions
'------------------------------------------------------------------------------
Private Sub CommandApply_Click()
  FormModelRescaler.Caption = Title & ": Working..."
  ListBoxCompleted.Clear                        ' Clear list of changed dims
  Set swFeat = Document.FirstFeature            ' Traverse features
  Do While Not swFeat Is Nothing
    Set swSubFeat = swFeat.GetFirstSubFeature   ' Traverse sub-features
    Do While Not swSubFeat Is Nothing
      FixFeature swSubFeat                      ' Change dimensions
      Set swSubFeat = swSubFeat.GetNextSubFeature
    Loop
    FixFeature swFeat                           ' Change dimensions
    Set swFeat = swFeat.GetNextFeature
  Loop
  Document.ForceRebuild                         ' Forde model rebuild
  Document.GraphicsRedraw2                      ' Redraw gfx window
  FormModelRescaler.Caption = Title & ": Done..."
End Sub

Private Sub CommandClose_Click()
  End
End Sub

Private Sub OptionButtonIncrement_Click()
  LabelValue.Caption = "+"
  ShowTitle
End Sub

Private Sub OptionButtonDecrement_Click()
  LabelValue.Caption = "-"
  ShowTitle
End Sub

Private Sub TextBoxFactor_Change()
  ShowTitle
End Sub

Private Sub ShowTitle()
  FormModelRescaler.Caption = Title
End Sub

Sub UserForm_Initialize()
  Title = FormModelRescaler.Caption
  OptionButtonIncrement.Value = True
  OptionButtonDecrement.Value = False
  TextBoxFactor.Value = 25.4
  FormModelRescaler.Caption = Title & " " & Version
End Sub

